<template>
  <form class="form" @submit.prevent="submitData">
    <h2 class="form__title">
      <span>Sign Up</span>
      and find the best place to rest while traveling
    </h2>
    <div class="form__fields">
      <!-- NAME -->
      <Input
        type="text"
        label="First Name"
        id="name"
        v-model.trim="user.name.value"
        :error="user.name.error"
        :icon="require('@/assets/images/icons/user.svg')"
        @validate-input="validateInput($event.target.value, 'name', fv.validateNameField)"
      />

      <!-- SURNAME -->
      <Input
        type="text"
        label="Second Name"
        id="surname"
        v-model.trim="user.surname.value"
        :icon="require('@/assets/images/icons/users.svg')"
        :error="user.surname.error"
        @validate-input="validateInput($event.target.value, 'surname', fv.validateNameField)"
      />

      <!-- COUNTRY -->
      <Select
        :options="countries"
        label="Country"
        id="country"
        v-model="user.country.value"
        :error="user.country.error"
        :icon="require('@/assets/images/icons/map-marker.svg')"
        @validate-input="validateInput($event.value, 'country', fv.validateCountryField)"
      />

      <!-- PHONE -->
      <Input
        type="tel"
        label="Phone"
        id="phone"
        v-model.trim="user.phone.value"
        :error="user.phone.error"
        :mask="currentPhoneMask"
        :icon="require('@/assets/images/icons/phone.svg')"
        @validate-input="validateInput($event.target.value, 'phone', fv.validatePhoneField, currentPhoneMask)"
      />

      <!-- PASSWORD -->
      <Input
        type="password"
        label="Password"
        id="password"
        v-model.trim="user.password.value"
        :error="user.password.error"
        :icon="require('@/assets/images/icons/padlock.svg')"
        @validate-input="validateInput($event.target.value, 'password', fv.validatePasswordField)"
      />

      <!-- CONFIRM PASSWORD -->
      <Input
        type="password"
        label="Confirm password"
        id="confirm-password"
        v-model.trim="user.confirmPassword.value"
        :error="user.confirmPassword.error"
        :icon="require('@/assets/images/icons/padlock2.svg')"
        @validate-input="
          validateInput($event.target.value, 'confirmPassword', fv.validateConfirmPasswordField, user.password.value)
        "
      />

      <!-- EMAIL -->
      <Input
        type="email"
        label="Email"
        id="email"
        v-model.trim="user.email.value"
        :icon="require('@/assets/images/icons/envelope.svg')"
        :error="user.email.error"
        @validate-input="validateInput($event.target.value, 'email', fv.validateEmailField)"
      />

      <!-- TERMS -->
      <Checkbox id="terms" v-model:checked="agreement">
        <template #label
          >I agree to the
          <a href="#" class="form__link">Terms & Conditions</a>
        </template>
      </Checkbox>
    </div>

    <!-- SUBMIT -->
    <Button label="Sign Up" type="submit" class="form__submit" :disabled="isSignupButtonDisabled" />
  </form>
</template>
<script>
import { reactive, computed, ref, watch, defineComponent, onUnmounted } from "vue"
import useFormValidation from "@/use/useFormValidation.js"
import countries from "@/countries.json"

import Input from "@/components/shared/Input"
import Select from "@/components/shared/Select"
import Checkbox from "@/components/shared/Checkbox"
import Button from "@/components/shared/Button"

export default defineComponent({
  name: "RegistrationForm",
  components: { Input, Button, Select, Checkbox },
  setup() {
    const user = reactive({
      name: { value: null, error: null, isValid: false },
      surname: { value: null, error: null, isValid: false },
      country: { value: null, error: null, isValid: false },
      phone: { value: null, error: null, isValid: false },
      email: { value: null, error: null, isValid: false },
      password: { value: null, error: null, isValid: false },
      confirmPassword: { value: null, error: null, isValid: false },
    })
    const agreement = ref(true)
    const fv = useFormValidation()

    // get current phone mask by country
    const currentPhoneMask = computed(() => {
      if (user.country.value == null) {
        return "###-##-##"
      } else {
        const { code, mask } = user.country.value
        return Array.isArray(mask) ? mask.map(mask => `${code} ${mask}`) : `${code} ${mask}`
      }
    })

    const validateInput = (fieldValue, fieldName, validationFn, ...rest) => {
      // clear field error
      fv.clearFieldError(user[fieldName])

      // get current field error
      const error = validationFn(fieldValue, rest)

      if (error !== null) {
        // set field error
        fv.setFieldError(user[fieldName], error)
      }
    }

    // check all fields for validity
    const isSignupButtonDisabled = computed(() => {
      let disabled = true

      if (!agreement.value) return disabled

      for (let prop in user) {
        if (!user[prop].isValid) {
          disabled = true
          break
        }
        disabled = false
      }

      return disabled
    })

    // check confirm password
    const unwatch = watch(
      () => user.password.value,
      newPassword => {
        if (user.confirmPassword.value) {
          validateInput(user.confirmPassword.value, "confirmPassword", fv.validateConfirmPasswordField, newPassword)
        }
      }
    )

    // submit data
    const submitData = async () => {
      console.log("submit!")
    }

    // stop watching
    onUnmounted(() => unwatch())

    return {
      countries,
      user,
      fv,
      currentPhoneMask,
      submitData,
      validateInput,
      isSignupButtonDisabled,
      agreement,
    }
  },
})
</script>
